#include "includes.h"


void RCC_Configuration(void);
void NVIC_Configuration(void);
void GPIO_Configuration(void);
void USART1_Configuration(void);
//void DMA_Configuration(void);

void Init_Device(void)
{
  RCC_Configuration();
  GPIO_Configuration();
  NVIC_Configuration();
  USART1_Configuration();
}


void RCC_Configuration(void)
{
    SystemInit();
}


void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA | RCC_AHBPeriph_GPIOB | RCC_AHBPeriph_GPIOC , ENABLE);   /* Enable GPIO clock */

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 , ENABLE);   /* Enable UART clock */
  
  /* Connect PA9 to USART1_Tx */
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_USART1);
  /* Connect PA10 to USART1_Rx*/
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_USART1);
  /* Configure USART1_Tx and USART1_Rx as alternate function */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_40MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  

}


void USART1_Configuration(void)
{  
  /* USART resources configuration (Clock, GPIO pins and USART registers) ----*/
  /* USART configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled*/
  USART_InitTypeDef USART_InitStructure;
  USART_ClockInitTypeDef USART_ClockIni;

  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  
  USART_ClockIni.USART_Clock = USART_Clock_Disable;
  USART_ClockIni.USART_CPOL = USART_CPOL_Low;
  USART_ClockIni.USART_CPHA = USART_CPHA_2Edge;
  USART_ClockIni.USART_LastBit = USART_LastBit_Disable;

  /* USART configuration */
  USART_Init(USART1, &USART_InitStructure);
  USART_ClockInit(USART1,&USART_ClockIni);
  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
//  USART_ITConfig(USART1, USART_IT_TXE, DISABLE);//
  USART_Cmd(USART1, ENABLE);
}



/*******************************************************************************
* Function Name  : NVIC_Configuration
* Description    : NVIC
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void NVIC_Configuration(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
#ifdef  VECT_TAB_RAM
    // Set the Vector Table base location at 0x20000000
    NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
#else  /* VECT_TAB_FLASH  */
    // Set the Vector Table base location at 0x08000000
    NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
#endif
    //NVICȼΪGroup20-3ռʽȼ0-3Ӧʽȼ
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    //ڽжϴ   
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}


void PutCharToUart1Continue(unsigned char p[],unsigned char Num)
{   
    unsigned char i=0;
    while(Num--)  
    {
        Uart1.TxBuffer[Uart1.TxIn] = p[i];
        i++;
        Uart1.TxIn = (Uart1.TxIn + 1)&UARTTXBUFFERLENGTH;
    }
        USART_ITConfig(USART1, USART_IT_TXE, ENABLE); 

}